<?php
namespace Ak\Mail\Transport;

use Interop\Container\ContainerInterface;
use Zend\Mail\Transport\Smtp;
use Zend\Mail\Transport\SmtpOptions;
use Zend\ServiceManager\Factory\FactoryInterface;

final class SmtpFactory implements FactoryInterface
{

    /**
     * Create an object
     *
     * @param  ContainerInterface $container
     * @param  string $requestedName
     * @param  null|array $options
     *
     * @return Smtp
     */
    public function __invoke(ContainerInterface $container, $requestedName, array $options = null)
    {
        $options = new SmtpOptions($options ?? []);
        return new Smtp($options);
    }
}