<?php
namespace Ak\Mail\Transport;

use Zend\Mail\Transport\File;
use Zend\Mail\Transport\InMemory;
use Zend\Mail\Transport\Sendmail;
use Zend\Mail\Transport\Smtp;
use Zend\Mail\Transport\TransportInterface;
use Zend\ServiceManager\AbstractPluginManager;
use Zend\ServiceManager\Factory\InvokableFactory;

/**
 * Upravlja instancama mail transporta.
 *
 * @package Ak\Mail\Transport
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/autokreso/mail
 */
final class TransportPluginManager extends AbstractPluginManager
{
    const CONFIG_KEY = 'mail_transports';
    /** @var string  */
    protected $instanceOf = TransportInterface::class;
    /** @var array */
    protected $aliases = [
        'file'     => File::class,
        'inmemory' => InMemory::class,
        'sendgrid' => Sendgrid::class,
        'sendmail' => Sendmail::class,
        'smtp'     => Smtp::class,
    ];
    /** @var array */
    protected $factories = [
        File::class     => FileFactory::class,
        InMemory::class => InvokableFactory::class,
        Sendgrid::class => SendgridFactory::class,
        Sendmail::class => InvokableFactory::class,
        Smtp::class     => SmtpFactory::class,
    ];
}